// Cidmaker.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Cidmaker.h"
#include "CidmakerDlg.h"
#include <time.h>
#include <math.h>
#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCidmakerApp

BEGIN_MESSAGE_MAP(CCidmakerApp, CWinApp)
	//{{AFX_MSG_MAP(CCidmakerApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCidmakerApp construction

CCidmakerApp::CCidmakerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCidmakerApp object

CCidmakerApp theApp;

//----------------

#define SINES 264
#define LO8 60
#define LO6 80
#define HI8 33
#define HI6 44

unsigned char sine[12*22] = { // a sine wave in 264 samples
128,130,132,134,137,139,141,143,146,148,150,152,155,157,159,161,163,165,
167,169,171,174,176,177,179,181,183,185,187,189,190,192,194,195,197,199,
200,202,203,204,206,207,208,209,211,212,213,214,215,216,217,217,218,219,
220,220,221,221,222,222,223,223,223,223,223,223,223,223,223,223,223,223,
223,222,222,221,221,220,220,219,218,217,217,216,215,214,213,212,211,209,
208,207,206,204,203,202,200,199,197,195,194,192,190,189,187,185,183,181,
179,177,175,174,171,169,167,165,163,161,159,157,155,152,150,148,146,143,
141,139,137,134,132,130,127,125,123,121,118,116,114,112,109,107,105,103,
100,98,96,94,92,90,88,86,84,81,79,78,76,74,72,70,68,66,65,63,61,60,58,56,
55,53,52,51,49,48,47,46,44,43,42,41,40,39,38,38,37,36,35,35,34,34,33,33,
32,32,32,32,32,32,32,32,32,32,32,32,32,33,33,34,34,35,35,36,37,38,38,39,
40,41,42,43,44,46,47,48,49,51,52,53,55,56,58,60,61,63,65,66,68,70,72,74,
76,78,80,81,84,86,88,90,92,94,96,98,100,103,105,107,109,112,114,116,118,
121,123,125
};


int write_bit (int bit, 			// one or zero
								int samples, 	// six or eight
								FILE * fo, 		// file handle
								int * count, 	// offset for last sample
								long * writes,	// bytes written to file
								int noise);

int write_byte (int byte,			// the byte
								int samples,	// six or eight
								FILE * fo,		// file handle
								int * count,		// offset of last sample
								long * writes,
								int noise);

long writes = 0;
int nextsample;

/////////////////////////////////////////////////////////////////////////////
// CCidmakerApp initialization

BOOL CCidmakerApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

struct _waveheader {
	char 	riff[4];
	long 	block_size;
	char 	wave[4];
	char 	fmt[4];
	int 	chunk_size;
	short tag;
	short	channels;
	int		samples_per_sec;
	int		bytes_per_sec;
	short	block_align;
	short	bits_per_sample;
	char	data[4];
	int	data_size;
	};


_waveheader wh;              			// header for wave files
FILE * fo;
int q;
char tdate[10];
SYSTEMTIME systime;
int bitrate;

	CCidmakerDlg dlg;
	m_pMainWnd = &dlg;

	int nResponse = dlg.DoModal();

	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK

		// sort out the bitrate
		if (dlg.m_Samplerate == 0)
			bitrate = 6;
		else
			bitrate = 8;

		// make the file
		fo = fopen(dlg.m_Filename,"wb");	// write binary output data
		
		// set up the header block
		memcpy (wh.riff,"RIFF",4);
		wh.block_size = 0;		// to fill in later - will be wh.data + 36
		memcpy (wh.wave,"WAVE",4);
		memcpy (wh.fmt,"fmt ",4);
		wh.chunk_size = 16;   // size of data chunk
		wh.tag = 1;           // pcm data
		wh.channels = 1;			// mono
		wh.samples_per_sec = 1200*bitrate;	// default rate, might be 9600
		wh.bytes_per_sec = 1200*bitrate;
		wh.block_align = 1;		// for eight bit mono
		wh.bits_per_sample = 8;	// eight bits
		memcpy (wh.data,"data",4);
		wh.data_size = 0;			// fill in later - total amount of data

		// write it to disc - will be corrected later
		fwrite(&wh,sizeof(wh),1,fo);

	// get the time and date
	GetLocalTime(&systime);
	sprintf(tdate,"%2d%2d",systime.wMonth,systime.wDay);
	sprintf(tdate+4,"%2d%2d",systime.wHour,systime.wMinute);
	// sort out leading spaces
	if (tdate[0] == ' ')
		tdate[0] = '0';
	if (tdate[2] == ' ')
		tdate[2] = '0';
	if (tdate[4] == ' ')
		tdate[4] = '0';
	if (tdate[6] == ' ')
		tdate[6] = '0';
TRACE ("date: %s\n",tdate);

	// start with the channel seizure (0x55 * 30)
	for (q=0; q<30; q++)
		write_byte (0x55, 			// the data
								bitrate,			 	// six or eight
								fo, 			// file handle
								&nextsample,		// offset for last sample
								&writes,
								dlg.m_NoisedB);
	// and then we dump the 180 +/- 25 marks...
	for (q=0; q<180; q++)
		write_bit (1,bitrate,fo,&nextsample,&writes,dlg.m_NoisedB);

char message[256];
int ptr = 0;

	message[ptr++] = (char)0x80;
	message[ptr++] = (char)0;

	// insert the time and date
	message[ptr++] = 0x01;
	message[ptr++] = 0x08;
	sprintf(message+ptr,tdate);
	ptr+=strlen(tdate);

	if (dlg.m_CallNumYN)
	{
		// insert phone number
		message[ptr++] = 0x02;
		message[ptr++] = strlen(dlg.m_Callernum);
		sprintf(message+ptr,"%s",dlg.m_Callernum);
		ptr+=strlen(dlg.m_Callernum);
	}
	else
	{
		// insert failure reason
		message[ptr++] = 0x04;		// reason
  	message[ptr++] = 1;				// message length
		switch (dlg.m_CallernameWhy)
		{
			case 1:
				message[ptr++] = 'P';		// withheld
				break;
			case 0:
				message[ptr++] = 'O';		// unavailable
				break;
			default:
				message[ptr++] = ' ';		// force error
		}
	}

	if (dlg.m_CallernameYN)
	{
		message[ptr++] = 0x07;
		message[ptr++] = strlen(dlg.m_Calllername);
		sprintf(message+ptr,"%s",dlg.m_Calllername);
		ptr+=strlen(dlg.m_Calllername);
	}
	else
	{
		// insert failure reason
		message[ptr++] = 0x08;		// reason
  	message[ptr++] = 1;				// message length
		switch(dlg.m_CallernumWhy)
		{
			case 1:
				message[ptr++] = 'P';		// withheld
				break;
			case 0:
				message[ptr++] = 'O';		// unavailable
				break;
			default:
				message[ptr++] = ' ';		// force error
		}
	}

	if (dlg.m_FwdIDYN)
	{
		message[ptr++] = 0x12;
		message[ptr++] = strlen(dlg.m_Fwdnumber);
		sprintf(message+ptr,"%s",dlg.m_Fwdnumber);
		ptr+=strlen(dlg.m_Fwdnumber);
	}

	if (dlg.m_CalltypeYN)
	{
		// insert call type
		message[ptr++] = 0x11;		// reason
  	message[ptr++] = 1;				// message length
		switch(dlg.m_CalltypeWhich)
		{
			case 0:
				message[ptr++] = 0x01;		// voice call
				break;
			case 1:
				message[ptr++] = 0x02;		// CLI ringback when free
				break;
			case 2:
				message[ptr++] = 0x03;		// Calling name delivery
				break;
			case 3:
				message[ptr++] = 0x81;		// Message waiting
				break;
			default:
				message[ptr++] = ' ';		// force error
		}
	}

	if (dlg.m_FwdcalltypeYN)
	{
		// insert call type
		message[ptr++] = 0x15;		// reason
  	message[ptr++] = 1;				// message length
		switch(dlg.m_FwdcalltypeWhich)
		{
			case 0:
				message[ptr++] = 0x00;		// unknown
				break;
			case 1:
				message[ptr++] = 0x01;		// on busy
				break;
			case 2:
				message[ptr++] = 0x02;		// no reply
				break;
			case 3:
				message[ptr++] = 0x03;		// unconditional
				break;
			case 4:
				message[ptr++] = 0x04;		// deflected after alert
				break;
			case 5:
				message[ptr++] = 0x05;		// deflected immediate
				break;
			case 6:
				message[ptr++] = 0x06;		// no mobile
				break;
			default:
				message[ptr++] = ' ';		// force error
		}
	}


	// insert the length byte
	message[1] = ptr-2;		//doesn't include the 0x80 or itself!

	// now a checksum
int	checksum = 0;
	for (q=0; q<ptr; q++)
		checksum += message[q];
	checksum = 0-checksum;
	message[ptr] = checksum&0xff;
TRACE ("total message %s\n",message);

	for (q=0; q<message[1]+3; q++)
		write_byte(message[q],bitrate,fo,&nextsample,&writes,dlg.m_NoisedB);
	for (q=0; q<10; q++)
		write_byte('x',bitrate,fo,&nextsample,&writes,dlg.m_NoisedB);

	fseek (fo,0,0);			// back to the beginning
	wh.data_size = writes;
	wh.block_size = wh.block_size+36;
	fwrite(&wh,sizeof(wh),1,fo);
		fclose(fo);
	}
	else// if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

int write_byte (int _byte,			// the byte
								int samples,	// six or eight
								FILE * fo,		// file handle
								int * count,		// offset of last sample
								long * writes,
								int noise)
{
	// first send start bit
	write_bit(0,samples,fo,count,writes,noise);
	// the data, low bit first
	for (int q=0; q<8; q++)
	{
		write_bit ((_byte & 1),samples,fo,count,writes,noise);
		_byte >>= 1;
	}
	// the stop bit
	write_bit (1,samples,fo,count,writes,noise);
	return 0;
}

int lines = 0;

int write_bit (int bit, 			// one or zero
								int samples, 	// six or eight
								FILE * fo, 		// file handle
								int * count,		// offset for last sample
								long * writes,
								int noise)
{
	// write a single bit to the file
int spacer;
int temp = bit+samples;
int q;
float ftemp;

	switch (temp)
	{
		case 6:
			// 0, low
			spacer = LO6;
			break;
		case 7:
			// 1, low
			spacer = HI6;
			break;
		case 8:
			// 0, hi
			spacer = LO8;
			break;
		case 9:
			// 1, hi
			spacer = HI8;
			break;
	}
	// now we have the right offset into adjacent samples
	for (q=0; q<samples; q++)
	{
		count[0] += spacer;
		if (count[0] >= SINES)
			count[0] -= SINES;
		// we have to include the noise now...
		// it comes in dB ref to 1 bit
		// convert noise to temp value
		ftemp = 0.0;
		if (noise>0)
		{
			ftemp = pow(10.0,(double)noise/20.0);
			ftemp *= (rand()-0x3fff);
			ftemp /= (float)0x7fff;
		}


		//fputc(sine[count[0]]+(unsigned char)ftemp,fo);
		fprintf(fo,"0x%02x,",sine[count[0]]);
		if (lines++ == 16)
		{
			lines = 0;
			fprintf(fo,"\n");
		}

		
		writes[0] ++;
	}
	return count[0];
}